stages:
  - build
  - upload
  - release

variables:
  # Package version should match \A(\.?[\w\+-]+\.?)+\z regular expresion.
  # See https://docs.gitlab.com/ee/user/packages/generic_packages/#publish-a-package-file
  PACKAGE_REGISTRY_URL: "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/${CI_PROJECT_NAME}/${CI_COMMIT_TAG}"

build:
  image: alvrme/alpine-android:android-35-jdk21
  stage: build
  rules:
    - if: $CI_COMMIT_TAG
  variables:
    SECURE_FILES_DOWNLOAD_PATH: './'
  script:
    - apt update -y && apt install -y curl
    - curl -s https://gitlab.com/gitlab-org/incubation-engineering/mobile-devops/download-secure-files/-/raw/main/installer | bash
    - chmod +x gradlew
    - ./gradlew assembleRelease
  artifacts:
    paths:
      - app/build/outputs/apk/release/app-release.apk
    expire_in: 1 week

upload:
  stage: upload
  image: curlimages/curl:latest
  rules:
    - if: $CI_COMMIT_TAG
  script:
    - |
      curl --header "JOB-TOKEN: ${CI_JOB_TOKEN}" --upload-file app/build/outputs/apk/release/app-release.apk ${PACKAGE_REGISTRY_URL}/app-release.apk

release:
  # Caution, as of 2021-02-02 these assets links require a login, see:
  # https://gitlab.com/gitlab-org/gitlab/-/issues/299384
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  rules:
    - if: $CI_COMMIT_TAG
  script:
    - |
      release-cli create --name "Release $CI_COMMIT_TAG" --tag-name $CI_COMMIT_TAG \
         --assets-link "{\"name\":\"app-release.apk\",\"url\":\"${PACKAGE_REGISTRY_URL}/app-release.apk\"}" 

